diff --git a/src/V3Dfg.h b/src/V3Dfg.h
index c76cc8bf2a3..bab4a0498f9 100644
--- a/src/V3Dfg.h
+++ b/src/V3Dfg.h
@@ -747,102 +653,62 @@ class DfgGraph final {
     // Returns the set of vertices in the downstream cones of the given vertices
     std::unique_ptr<std::unordered_set<const DfgVertex*>>
     sinkCone(const std::vector<const DfgVertex*>&) const VL_MT_DISABLED;
+};
 
-    //-----------------------------------------------------------------------
-    // Static methods for data types
-
-    // Some data types are interned, in order to facilitate type comparison
-    // via pointer compariosn. These are functoins to construct the canonical
-    // DFG data types
-
-    // Returns data type used to represent any packed value of the given 'width'.
-    static AstNodeDType* dtypePacked(uint32_t width) {
-        return v3Global.rootp()->typeTablep()->findLogicDType(width, width, VSigning::UNSIGNED);
-    }
+//------------------------------------------------------------------------------
+// Inline method definitions
 
-    // Returns data type used to represent any array with the given type and number of elements.
-    static AstNodeDType* dtypeArray(AstNodeDType* subDtypep, uint32_t size) {
-        UASSERT_OBJ(isSupported(subDtypep), subDtypep, "Unsupported element type");
-        FileLine* const flp = subDtypep->fileline();
-        AstRange* const rangep = new AstRange{flp, static_cast<int>(size - 1), 0};
-        AstNodeDType* const dtypep = new AstUnpackArrayDType{flp, subDtypep, rangep};
-        v3Global.rootp()->typeTablep()->addTypesp(dtypep);
-        return dtypep;
-    }
+// DfgEdge {{{
 
-    // Return data type used to represent the type of 'nodep' when converted to a DfgVertex
-    static AstNodeDType* toDfgDType(const AstNodeDType* dtypep) {
-        dtypep = dtypep->skipRefp();
-        UASSERT_OBJ(isSupported(dtypep), dtypep, "Unsupported dtype");
-        // For simplicity, all packed types are represented with a fixed type
-        if (const AstUnpackArrayDType* const uatp = VN_CAST(dtypep, UnpackArrayDType)) {
-            return dtypeArray(toDfgDType(uatp->subDTypep()), uatp->elementsConst());
-        }
-        return dtypePacked(dtypep->width());
-    }
-
-    //-----------------------------------------------------------------------
-    // Static methods for compatibility tests
-
-    // Returns true if the given data type can be represented in the graph
-    static bool isSupported(const AstNodeDType* dtypep) VL_MT_DISABLED;
-
-    // Returns true if variable can be represented in the graph
-    static bool isSupported(const AstVar* varp) {
-        if (varp->isIfaceRef()) return false;  // Cannot handle interface references
-        if (varp->delayp()) return false;  // Cannot handle delayed variables
-        if (varp->isSc()) return false;  // SystemC variables are special and rare, we can ignore
-        if (varp->dfgMultidriven()) return false;  // Discovered as multidriven on earlier DFG run
-        return isSupported(varp->dtypep());
+void DfgEdge::unlinkSrcp() {
+    if (!m_srcp) return;
+#ifdef VL_DEBUG
+    bool contained = false;
+    for (const DfgEdge& edge : m_srcp->m_sinks) {
+        if (&edge != this) continue;
+        contained = true;
+        break;
     }
+    UASSERT_OBJ(contained, m_srcp, "'m_srcp' does not have this as sink");
+#endif
+    m_srcp->m_sinks.unlink(this);
+    m_srcp = nullptr;
+}
 
-    // Returns true if variable can be represented in the graph
-    static bool isSupported(const AstVarScope* vscp) {
-        AstNodeModule* const modp = vscp->scopep()->modp();
-        if (VN_IS(modp, Module)) {
-            // Regular module supported
-        } else if (AstIface* const ifacep = VN_CAST(modp, Iface)) {
-            // Interfaces supported if there are no virtual interfaces for
-            // them, otherwise they cannot be resovled statically.
-            if (ifacep->hasVirtualRef()) return false;
-        } else {
-            return false;  // Anything else (package, class, etc) not supported
-        }
-        // Check the AstVar
-        return isSupported(vscp->varp());
-    }
-};
+void DfgEdge::relinkSrcp(DfgVertex* srcp) {
+    // Unlink current source, if any
+    unlinkSrcp();
+    m_srcp = srcp;
+    if (m_srcp) m_srcp->m_sinks.linkFront(this);
+}
 
-// Specializations of privateTypeTest
-#include "V3Dfg__gen_type_tests.h"  // From ./astgen
+// }}}
 
-//------------------------------------------------------------------------------
-// Inline method definitions - for DfgVertex
-//------------------------------------------------------------------------------
+// DfgVertex {{{
 
-template <typename T>
-T& DfgVertex::user() {
-    static_assert(sizeof(T) <= sizeof(UserDataStorage),
-                  "Size of user data type 'T' is too large for allocated storage");
-    static_assert(alignof(T) <= alignof(UserDataStorage),
-                  "Alignment of user data type 'T' is larger than allocated storage");
-    T* const storagep = reinterpret_cast<T*>(&m_userDataStorage);
+template <typename T_User>
+T_User& DfgVertex::user() {
+    static_assert(sizeof(T_User) <= sizeof(UserDataStorage),
+                  "Size of user data type 'T_User' is too large for allocated storage");
+    static_assert(alignof(T_User) <= alignof(UserDataStorage),
+                  "Alignment of user data type 'T_User' is larger than allocated storage");
+    T_User* const storagep = reinterpret_cast<T_User*>(&m_userDataStorage);
     const uint32_t userCurrent = m_graphp->m_userCurrent;
     UDEBUGONLY(UASSERT_OBJ(userCurrent, this, "DfgVertex user data used without reserving"););
     if (m_userCnt != userCurrent) {
         m_userCnt = userCurrent;
-        new (storagep) T{};
+        new (storagep) T_User{};
     }
     return *storagep;
 }
 
-template <typename T>
-const T& DfgVertex::getUser() const {
-    static_assert(sizeof(T) <= sizeof(UserDataStorage),
-                  "Size of user data type 'T' is too large for allocated storage");
-    static_assert(alignof(T) <= alignof(UserDataStorage),
-                  "Alignment of user data type 'T' is larger than allocated storage");
-    const T* const storagep = reinterpret_cast<const T*>(&m_userDataStorage);
+template <typename T_User>
+const T_User& DfgVertex::getUser() const {
+    static_assert(sizeof(T_User) <= sizeof(UserDataStorage),
+                  "Size of user data type 'T_User' is too large for allocated storage");
+    static_assert(alignof(T_User) <= alignof(UserDataStorage),
+                  "Alignment of user data type 'T_User' is larger than allocated storage");
+    const T_User* const storagep = reinterpret_cast<const T_User*>(&m_userDataStorage);
 #if VL_DEBUG
     const uint32_t userCurrent = m_graphp->m_userCurrent;
     UASSERT_OBJ(userCurrent, this, "DfgVertex user data used without reserving");
@@ -851,13 +717,18 @@ const T& DfgVertex::getUser() const {
     return *storagep;
 }
 
-template <typename T>
-void DfgVertex::setUser(T value) {
-    static_assert(sizeof(T) <= sizeof(UserDataStorage),
-                  "Size of user data type 'T' is too large for allocated storage");
-    static_assert(alignof(T) <= alignof(UserDataStorage),
-                  "Alignment of user data type 'T' is larger than allocated storage");
-    T* const storagep = reinterpret_cast<T*>(&m_userDataStorage);
+template <typename T_User>
+T_User& DfgVertex::getUser() {
+    return const_cast<T_User&>(const_cast<const DfgVertex*>(this)->getUser<T_User>());
+}
+
+template <typename T_User>
+void DfgVertex::setUser(T_User value) {
+    static_assert(sizeof(T_User) <= sizeof(UserDataStorage),
+                  "Size of user data type 'T_User' is too large for allocated storage");
+    static_assert(alignof(T_User) <= alignof(UserDataStorage),
+                  "Alignment of user data type 'T_User' is larger than allocated storage");
+    T_User* const storagep = reinterpret_cast<T_User*>(&m_userDataStorage);
     const uint32_t userCurrent = m_graphp->m_userCurrent;
 #if VL_DEBUG
     UASSERT_OBJ(userCurrent, this, "DfgVertex user data used without reserving");
@@ -866,207 +737,6 @@ void DfgVertex::setUser(T value) {
     *storagep = value;
 }
 
-void DfgVertex::forEachSource(std::function<void(DfgVertex&)> f) {
-    const auto pair = sourceEdges();
-    const DfgEdge* const edgesp = pair.first;
-    const size_t nEdges = pair.second;
-    for (size_t i = 0; i < nEdges; ++i) {
-        if (DfgVertex* const sourcep = edgesp[i].m_sourcep) f(*sourcep);
-    }
-}
-
-void DfgVertex::forEachSource(std::function<void(const DfgVertex&)> f) const {
-    const auto pair = sourceEdges();
-    const DfgEdge* const edgesp = pair.first;
-    const size_t nEdges = pair.second;
-    for (size_t i = 0; i < nEdges; ++i) {
-        if (DfgVertex* const sourcep = edgesp[i].m_sourcep) f(*sourcep);
-    }
-}
-
-void DfgVertex::forEachSink(std::function<void(DfgVertex&)> f) {
-    for (const DfgEdge *edgep = m_sinksp, *nextp; edgep; edgep = nextp) {
-        nextp = edgep->m_nextp;
-        f(*edgep->m_sinkp);
-    }
-}
-
-void DfgVertex::forEachSink(std::function<void(const DfgVertex&)> f) const {
-    for (const DfgEdge* edgep = m_sinksp; edgep; edgep = edgep->m_nextp) f(*edgep->m_sinkp);
-}
-
-void DfgVertex::forEachSourceEdge(std::function<void(DfgEdge&, size_t)> f) {
-    const auto pair = sourceEdges();
-    DfgEdge* const edgesp = pair.first;
-    const size_t nEdges = pair.second;
-    for (size_t i = 0; i < nEdges; ++i) f(edgesp[i], i);
-}
-
-void DfgVertex::forEachSourceEdge(std::function<void(const DfgEdge&, size_t)> f) const {
-    const auto pair = sourceEdges();
-    const DfgEdge* const edgesp = pair.first;
-    const size_t nEdges = pair.second;
-    for (size_t i = 0; i < nEdges; ++i) f(edgesp[i], i);
-}
-
-void DfgVertex::forEachSinkEdge(std::function<void(DfgEdge&)> f) {
-    for (DfgEdge *edgep = m_sinksp, *nextp; edgep; edgep = nextp) {
-        nextp = edgep->m_nextp;
-        f(*edgep);
-    }
-}
-
-void DfgVertex::forEachSinkEdge(std::function<void(const DfgEdge&)> f) const {
-    for (DfgEdge *edgep = m_sinksp, *nextp; edgep; edgep = nextp) {
-        nextp = edgep->m_nextp;
-        f(*edgep);
-    }
-}
-
-const DfgEdge* DfgVertex::findSourceEdge(std::function<bool(const DfgEdge&, size_t)> p) const {
-    const auto pair = sourceEdges();
-    const DfgEdge* const edgesp = pair.first;
-    const size_t nEdges = pair.second;
-    for (size_t i = 0; i < nEdges; ++i) {
-        const DfgEdge& edge = edgesp[i];
-        if (p(edge, i)) return &edge;
-    }
-    return nullptr;
-}
-
-template <typename Vertex>
-Vertex* DfgVertex::findSink(std::function<bool(const Vertex&)> p) const {
-    static_assert(std::is_base_of<DfgVertex, Vertex>::value,
-                  "'Vertex' must be subclass of 'DfgVertex'");
-    for (DfgEdge* edgep = m_sinksp; edgep; edgep = edgep->m_nextp) {
-        if (Vertex* const sinkp = edgep->m_sinkp->cast<Vertex>()) {
-            if (p(*sinkp)) return sinkp;
-        }
-    }
-    return nullptr;
-}
-
-template <typename Vertex>
-Vertex* DfgVertex::findSink() const {
-    static_assert(!std::is_same<DfgVertex, Vertex>::value,
-                  "'Vertex' must be proper subclass of 'DfgVertex'");
-    return findSink<Vertex>([](const Vertex&) { return true; });
-}
-
-bool DfgVertex::isZero() const {
-    if (const DfgConst* const constp = cast<DfgConst>()) return constp->isZero();
-    return false;
-}
-
-bool DfgVertex::isOnes() const {
-    if (const DfgConst* const constp = cast<DfgConst>()) return constp->isOnes();
-    return false;
-}
-
-//------------------------------------------------------------------------------
-// Inline method definitions - for DfgConst
-//------------------------------------------------------------------------------
-
-DfgConst::DfgConst(DfgGraph& dfg, FileLine* flp, const V3Number& num)
-    : DfgVertex{dfg, dfgType(), flp, DfgGraph::dtypePacked(num.width())}
-    , m_num{num} {}
-DfgConst::DfgConst(DfgGraph& dfg, FileLine* flp, uint32_t width, uint32_t value)
-    : DfgVertex{dfg, dfgType(), flp, DfgGraph::dtypePacked(width)}
-    , m_num{flp, static_cast<int>(width), value} {}
-
-//------------------------------------------------------------------------------
-// Inline method definitions - for DfgVertexSplice
-//------------------------------------------------------------------------------
-
-DfgVertex* DfgVertexSplice::wholep() const {
-    if (defaultp()) return nullptr;
-    if (arity() != 1) return nullptr;
-    if (driverLo(0) != 0) return nullptr;
-    DfgVertex* const srcp = DfgVertexVariadic::source(1);
-    if (srcp->size() != size()) return nullptr;
-    if (const DfgUnitArray* const uap = srcp->cast<DfgUnitArray>()) {
-        if (const DfgVertexSplice* sp = uap->srcp()->cast<DfgVertexSplice>()) {
-            if (!sp->wholep()) return nullptr;
-        }
-    }
-    return srcp;
-}
-
-//------------------------------------------------------------------------------
-// Inline method definitions - for DfgVertexVar
-//------------------------------------------------------------------------------
-
-DfgVertexVar::DfgVertexVar(DfgGraph& dfg, VDfgType type, AstVar* varp)
-    : DfgVertexUnary{dfg, type, varp->fileline(), DfgGraph::toDfgDType(varp->dtypep())}
-    , m_varp{varp}
-    , m_varScopep{nullptr} {
-    UASSERT_OBJ(dfg.modulep(), varp, "Un-scoped DfgVertexVar created in scoped DfgGraph");
-    UASSERT_OBJ(!m_varp->isSc(), varp, "SystemC variable is not representable by DfgVertexVar");
-    // Increment reference count
-    varp->user1(varp->user1() + 0x10);
-    UASSERT_OBJ((varp->user1() >> 4) > 0, varp, "Reference count overflow");
-}
-DfgVertexVar::DfgVertexVar(DfgGraph& dfg, VDfgType type, AstVarScope* vscp)
-    : DfgVertexUnary{dfg, type, vscp->fileline(), DfgGraph::toDfgDType(vscp->varp()->dtypep())}
-    , m_varp{vscp->varp()}
-    , m_varScopep{vscp} {
-    UASSERT_OBJ(!dfg.modulep(), vscp, "Scoped DfgVertexVar created in un-scoped DfgGraph");
-    UASSERT_OBJ(!m_varp->isSc(), vscp, "SystemC variable is not representable by DfgVertexVar");
-    // Increment reference count
-    vscp->user1(vscp->user1() + 0x10);
-    UASSERT_OBJ((vscp->user1() >> 4) > 0, vscp, "Reference count overflow");
-}
-
-DfgVertexVar::~DfgVertexVar() {
-    // Decrement reference count
-    // cppcheck-suppress shadowFunction
-    AstNode* const nodep = this->nodep();
-    nodep->user1(nodep->user1() - 0x10);
-    UASSERT_OBJ((nodep->user1() >> 4) >= 0, nodep, "Reference count underflow");
-}
-
-//------------------------------------------------------------------------------
-// Inline method definitions - for DfgGraph
-//------------------------------------------------------------------------------
-
-void DfgGraph::addVertex(DfgVertex& vtx) {
-    // Note: changes here need to be replicated in DfgGraph::mergeGraph
-    ++m_size;
-    if (DfgConst* const cVtxp = vtx.cast<DfgConst>()) {
-        m_constVertices.linkBack(cVtxp);
-    } else if (DfgVertexVar* const vVtxp = vtx.cast<DfgVertexVar>()) {
-        m_varVertices.linkBack(vVtxp);
-    } else {
-        m_opVertices.linkBack(&vtx);
-    }
-    vtx.m_userCnt = 0;
-    vtx.m_graphp = this;
-}
-
-void DfgGraph::removeVertex(DfgVertex& vtx) {
-    // Note: changes here need to be replicated in DfgGraph::mergeGraph
-    --m_size;
-    if (DfgConst* const cVtxp = vtx.cast<DfgConst>()) {
-        m_constVertices.unlink(cVtxp);
-    } else if (DfgVertexVar* const vVtxp = vtx.cast<DfgVertexVar>()) {
-        m_varVertices.unlink(vVtxp);
-    } else {
-        m_opVertices.unlink(&vtx);
-    }
-    vtx.m_userCnt = 0;
-    vtx.m_graphp = nullptr;
-}
-
-void DfgGraph::forEachVertex(std::function<void(DfgVertex&)> f) {
-    for (DfgVertexVar* const vtxp : m_varVertices.unlinkable()) f(*vtxp);
-    for (DfgConst* const vtxp : m_constVertices.unlinkable()) f(*vtxp);
-    for (DfgVertex* const vtxp : m_opVertices.unlinkable()) f(*vtxp);
-}
-
-void DfgGraph::forEachVertex(std::function<void(const DfgVertex&)> f) const {
-    for (const DfgVertexVar& vtx : m_varVertices) f(vtx);
-    for (const DfgConst& vtx : m_constVertices) f(vtx);
-    for (const DfgVertex& vtx : m_opVertices) f(vtx);
-}
+// }}}
 
 #endif
diff --git a/src/V3DfgAstToDfg.cpp b/src/V3DfgAstToDfg.cpp
index 18df9a1b082..bdc19039474 100644
--- a/src/V3DfgAstToDfg.cpp
+++ b/src/V3DfgAstToDfg.cpp
@@ -46,6 +46,7 @@ class AstToDfgVisitor final : public VNVisitor {
     // STATE
     DfgGraph& m_dfg;  // The graph being built
     V3DfgAstToDfgContext& m_ctx;  // The context for stats
+    AstScope* m_scopep = nullptr;  // The current scope, iff T_Scoped
 
     // METHODS
     static Variable* getTarget(const AstVarRef* refp) {
@@ -104,7 +105,7 @@ class AstToDfgVisitor final : public VNVisitor {
             if (VN_IS(vrefp, VarXRef)) return true;
             if (vrefp->access().isReadOnly()) return false;
             Variable* const varp = getTarget(VN_AS(vrefp, VarRef));
-            if (!DfgGraph::isSupported(varp)) return true;
+            if (!V3Dfg::isSupported(varp)) return true;
             if (!varp->user3SetOnce()) resp->emplace_back(getVarVertex(varp));
             return false;
         });
@@ -126,7 +127,7 @@ class AstToDfgVisitor final : public VNVisitor {
             if (VN_IS(vrefp, VarXRef)) return true;
             if (vrefp->access().isWriteOnly()) return false;
             Variable* const varp = getTarget(VN_AS(vrefp, VarRef));
-            if (!DfgGraph::isSupported(varp)) return true;
+            if (!V3Dfg::isSupported(varp)) return true;
             if (!varp->user3SetOnce()) resp->emplace_back(getVarVertex(varp));
             return false;
         });
@@ -152,7 +153,7 @@ class AstToDfgVisitor final : public VNVisitor {
         std::unique_ptr<std::vector<DfgVertexVar*>> resp{new std::vector<DfgVertexVar*>{}};
         resp->reserve(varps->size());
         for (Variable* const varp : *varps) {
-            if (!DfgGraph::isSupported(varp)) {
+            if (!V3Dfg::isSupported(varp)) {
                 ++m_ctx.m_nonRepVar;
                 return nullptr;
             }
@@ -188,7 +189,7 @@ class AstToDfgVisitor final : public VNVisitor {
         const std::unique_ptr<std::vector<DfgVertexVar*>> iVarpsp = gatherRead(nodep);
         if (!iVarpsp) return false;
         // Create the DfgLogic
-        DfgLogic* const logicp = new DfgLogic{m_dfg, nodep};
+        DfgLogic* const logicp = new DfgLogic{m_dfg, nodep, m_scopep};
         // Connect it up
         connect(*logicp, *iVarpsp, *oVarpsp);
         // Done
@@ -218,7 +219,7 @@ class AstToDfgVisitor final : public VNVisitor {
         const std::unique_ptr<std::vector<DfgVertexVar*>> iVarpsp = gatherLive(*cfgp);
         if (!iVarpsp) return false;
         // Create the DfgLogic
-        DfgLogic* const logicp = new DfgLogic{m_dfg, nodep, std::move(cfgp)};
+        DfgLogic* const logicp = new DfgLogic{m_dfg, nodep, m_scopep, std::move(cfgp)};
         // Connect it up
         connect(*logicp, *iVarpsp, *oVarpsp);
         // Done
@@ -241,7 +242,11 @@ class AstToDfgVisitor final : public VNVisitor {
         }
     }
     void visit(AstTopScope* nodep) override { iterate(nodep->scopep()); }
-    void visit(AstScope* nodep) override { iterateChildren(nodep); }
+    void visit(AstScope* nodep) override {
+        VL_RESTORER(m_scopep);
+        m_scopep = nodep;
+        iterateChildren(nodep);
+    }
     void visit(AstActive* nodep) override {
         if (nodep->hasCombo()) {
             iterateChildren(nodep);
@@ -268,6 +273,8 @@ class AstToDfgVisitor final : public VNVisitor {
         , m_ctx{ctx} {
         iterate(&root);
     }
+    VL_UNCOPYABLE(AstToDfgVisitor);
+    VL_UNMOVABLE(AstToDfgVisitor);
 
 public:
     static void apply(DfgGraph& dfg, RootType& root, V3DfgAstToDfgContext& ctx) {
